#include <stdio.h>
#include <stdlib.h>

int *ivector(int n)
{
    int *v;
    v = (int *)malloc((unsigned) (n)*sizeof(int));
    if (!v) fprintf(stderr, "Memory allocation failure in ivector()\n");
    return v;
}

double *vector(int n)
{
    double *v;
    v = (double *)malloc((unsigned) (n)*sizeof(double));
    if (!v) fprintf(stderr, "Memory allocation failure in vector()\n");
    return v;
}

double **matrix(int nr, int nc)
{
    int i;
    double **m;

    m = (double **)malloc((unsigned) (nr)*sizeof(double*));
    if (!m) fprintf(stderr, "Memory allocation failure 1 in matrix()\n");
    for (i = 0; i < nr; i++) {
        m[i] = (double *)malloc((unsigned) (nc)*sizeof(double));
        if (!m) fprintf(stderr, "Memory allocation failure 2 in matrix()\n");
    }
    return m;
}

void free_vector(double *v)
{
    free((char*) (v));
}

void free_matrix(double **m, int n)
{
    int i;
    for (i = n-1; i >= 0; i--) free((char*) (m[i]));
    free((char*)(m));
}

void free_ivector(int *v)
{
    free((char*) (v));
}
