#define K_UNDEF        -1

#define KW_INT          0
#define KW_REAL         1
#define KW_STRING       2
#define KW_INT_VEC      3
#define KW_REAL_VEC     4
#define KW_INT_ARR      5
#define KW_REAL_ARR     6

typedef struct {
    char   *c;
    int    *i;
    double *d;
    double **a;
} KW_PTR;

typedef struct {
    char   label[20];
    int    type, len;
    char   form[20];
    KW_PTR p;
} KW_STRUCT;

static char lab1[180], lab2[180], lab3[180];
static int n_levs, n_rtrans, n_ctrans, n_tk;
static int n1_ctrans=0, n1_tk=0;
static double molw, egy[MAX_LEVEL], g[MAX_LEVEL];
static int ul[MAX_RTRANS], ll[MAX_RTRANS], c_ul[MAX_CTRANS], c_ll[MAX_CTRANS];
static int c1_ul[MAX_CTRANS], c1_ll[MAX_CTRANS];
static double aul[MAX_RTRANS], c_tk[MAX_CTEMP], c1_tk[MAX_CTEMP];
static double c_coeffs[MAX_CTEMP][MAX_CTRANS];
static double c1_coeffs[MAX_CTEMP][MAX_CTRANS];

static KW_STRUCT kw[] = {
    {"LABEL1",      KW_STRING,   0,   "",      {lab1, NULL, NULL, NULL}},
    {"MOLW",        KW_REAL,     0,   "",      {NULL, NULL, &molw, NULL}},
    {"NLEVS",       KW_INT,      0,   "",      {NULL, &n_levs, NULL, NULL}},
    {"NTRANS",      KW_INT,      0,   "",      {NULL, &n_rtrans, NULL, NULL}},
    {"ENERGIES",    KW_REAL_VEC, 13,  "%13lf", {NULL, NULL, egy, NULL}},
    {"WEIGHTS",     KW_REAL_VEC, 5,   "%5lf",  {NULL, NULL, g, NULL}},
    {"RAD_UPPER",   KW_INT_VEC,  3,   "%d",    {NULL, ul, NULL, NULL}},
    {"RAD_LOWER",   KW_INT_VEC,  3,   "%d",    {NULL, ll, NULL, NULL}},
    {"A_COEFFS",    KW_REAL_VEC, 10,  "%10lf", {NULL, NULL, aul, NULL}},
    {"LABEL2",      KW_STRING,   0,   "",      {lab2, NULL, NULL, NULL}},
    {"COL_TRANS",   KW_INT,      0,   "",      {NULL, &n_ctrans, NULL, NULL}},
    {"COL_NTK",     KW_INT,      0,   "",      {NULL, &n_tk, NULL, NULL}},
    {"COL_TK",      KW_REAL_VEC, 6,   "%6lf",  {NULL, NULL, c_tk, NULL}},
    {"COL_UPPER",   KW_INT_VEC,  3,   "%d",    {NULL, c_ul, NULL, NULL}},
    {"COL_LOWER",   KW_INT_VEC,  3,   "%d",    {NULL, c_ll, NULL, NULL}},
    {"C_COEFFS",    KW_REAL_ARR, 9,   "%9lf",  {NULL, NULL, NULL, NULL}},
    {"LABEL3",      KW_STRING,   0,   "",      {lab3, NULL, NULL, NULL}},
    {"COL1_TRANS",  KW_INT,      0,   "",      {NULL, &n1_ctrans, NULL, NULL}},
    {"COL1_NTK",    KW_INT,      0,   "",      {NULL, &n1_tk, NULL, NULL}},
    {"COL1_TK",     KW_REAL_VEC, 6,   "%6lf",  {NULL, NULL, c1_tk, NULL}},
    {"COL1_UPPER",  KW_INT_VEC,  3,   "%d",    {NULL, c1_ul, NULL, NULL}},
    {"COL1_LOWER",  KW_INT_VEC,  3,   "%d",    {NULL, c1_ll, NULL, NULL}},
    {"C1_COEFFS",   KW_REAL_ARR, 8,   "%8lf",  {NULL, NULL, NULL, NULL}}
};
