#ifndef VECTOR
#define VECTOR
#endif

typedef struct {
    double x, y, z;
} CARTESIAN;

typedef struct {
    double r, theta, phi;
} SPHERICAL;

typedef struct {
    double r, phi, z;
} POLAR;

/* Prototypes */
void S_to_C(SPHERICAL, CARTESIAN *);
void C_to_S(CARTESIAN, SPHERICAL *);
void P_to_S(POLAR, SPHERICAL *);
void S_to_P(SPHERICAL, POLAR *);
void P_to_C(POLAR, CARTESIAN *);
void C_to_P(CARTESIAN, POLAR *);

void   C_neg(CARTESIAN, CARTESIAN *);
void   C_line(CARTESIAN, CARTESIAN, double, CARTESIAN *);
void   C_add(CARTESIAN, CARTESIAN, CARTESIAN *);
void   C_sub(CARTESIAN, CARTESIAN, CARTESIAN *);
double C_dot(CARTESIAN, CARTESIAN);
void   C_cross(CARTESIAN, CARTESIAN, CARTESIAN *);
double C_magn(CARTESIAN);
void   C_norm(CARTESIAN, CARTESIAN *);

void   S_neg(SPHERICAL, SPHERICAL *);
void   S_add(SPHERICAL, SPHERICAL, SPHERICAL *);
void   S_sub(SPHERICAL, SPHERICAL, SPHERICAL *);
double S_dot(SPHERICAL, SPHERICAL);
void   S_cross(SPHERICAL, SPHERICAL, SPHERICAL *);
double S_magn(SPHERICAL);
void   S_norm(SPHERICAL, SPHERICAL *);

void   P_neg(POLAR, POLAR *);
void   P_add(POLAR, POLAR, POLAR *);
void   P_sub(POLAR, POLAR, POLAR *);
double P_dot(POLAR, POLAR);
void   P_cross(POLAR, POLAR, POLAR *);
double P_magn(POLAR);
void   P_norm(POLAR, POLAR *);
