#include <stdio.h>
#include <string.h>

#ifndef PRF_EXTERNAL
#define PRF_EXTERNAL
#endif
#include "prf.h"

#define FITS_DIR	"FITS/"

extern double Tant[MAX_VEL], Vel[MAX_VEL], Tau0[MAX_VEL], SourceFlux[MAX_VEL];
extern double Tbri[MAX_VEL], Trad[MAX_VEL], DeltaI[MAX_VEL];

char *SourceName(const char *type)
{
    int n, len1, i = 0;
    char c;
    static char str[19];

    strncpy(str, prf.Source, 18);

    len1 = (int)strlen(str);

    for (n = len1; n <= 18; n++) {
        if (n == 18) {
            str[n] = '\0';
        } else if (n == len1) {
            str[n] = ' ';
        } else {
            c = type[i];
            if (c == '\0') {
                str[n] = c;
                break;
            }
            str[n] = c;
            i++;
        }
    }

    return str;
}

void store(int k)
{
    int i, n;
    static int scan = 0;
    char tag[200];
    char fitsfile[200];

    int Prf_to_Fits();

    n = pos[k].trans;

    fprintf(logs.fp, "# Tant[%d]    Itot=%e\n", k, pos[k].Itot);
    for (i = 0; i < prf.Nvel; i++) {
        fprintf(logs.fp, "%3d %12.5e %12.5e %12.5e %12.5e %12.5e\n",
                i, Vel[i], Tant[i], Tau0[i], Trad[i], Tbri[i]);
    }

    sprintf(tag, "_%d-%d_%d", tra[n].u, tra[n].l, k);
    strcpy(fitsfile, FITS_DIR);
    strcat(fitsfile, prf.Molecule);
    strcat(fitsfile, tag);
    strcat(fitsfile, ".fits");
    Prf_to_Fits(scan++, k, fitsfile, SourceName("Tant"), Tant); 

    sprintf(tag, "_%d-%d_%d_tau", tra[n].u, tra[n].l, k);
    strcpy(fitsfile, FITS_DIR);
    strcat(fitsfile, prf.Molecule);
    strcat(fitsfile, tag);
    strcat(fitsfile, ".fits");
    Prf_to_Fits(scan++, k, fitsfile, SourceName("Tau"), Tau0); 

    sprintf(tag, "_%d-%d_%d_Tbri0", tra[n].u, tra[n].l, k);
    strcpy(fitsfile, FITS_DIR);
    strcat(fitsfile, prf.Molecule);
    strcat(fitsfile, tag);
    strcat(fitsfile, ".fits");
    Prf_to_Fits(scan++, k, fitsfile, SourceName("Tbr_RJ-Tbg"), DeltaI); 

    sprintf(tag, "_%d-%d_%d_Flux", tra[n].u, tra[n].l, k);
    strcpy(fitsfile, FITS_DIR);
    strcat(fitsfile, prf.Molecule);
    strcat(fitsfile, tag);
    strcat(fitsfile, ".fits");
    Prf_to_Fits(scan++, k, fitsfile, SourceName("Flux"), SourceFlux); 

    sprintf(tag, "_%d-%d_%d_Trad", tra[n].u, tra[n].l, k);
    strcpy(fitsfile, FITS_DIR);
    strcat(fitsfile, prf.Molecule);
    strcat(fitsfile, tag);
    strcat(fitsfile, ".fits");
    Prf_to_Fits(scan++, k, fitsfile, SourceName("Tbr"), Trad); 
}
